//	ThreeWayDispenser.cpp - A three-way shot dispenser.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "ThreeWayDispenser.h"
#include "GamePlayState.h"
#include "Tank.h"

//------------------------------------------------------------------------------
ThreeWayDispenser::ThreeWayDispenser()
{

}

//------------------------------------------------------------------------------
ThreeWayDispenser::~ThreeWayDispenser()
{

}

//------------------------------------------------------------------------------
bool ThreeWayDispenser::firePrimary(const Tank& tank, GamePlayState& state)
{
	TwoFloats dir(-sinf(tank.getAngle()), cosf(tank.getAngle()));

	dir.x = -sinf(tank.getAngle()-0.2f);
	dir.y = cosf(tank.getAngle()-0.2f);
	state.firePrimary(tank.getPosition()+(dir*(tank.getRadius()+6.0f)),
					  dir,
					  tank.getColour(),
					  tank.getActualName());

	dir.x = -sinf(tank.getAngle()+0.2f);
	dir.y = cosf(tank.getAngle()+0.2f);
	state.firePrimary(tank.getPosition()+(dir*(tank.getRadius()+6.0f)),
					  dir,
					  tank.getColour(),
					  tank.getActualName());

	return true;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void ThreeWayDispenserCreator::apply(GamePlayState& state)
{
	int i;

	for(i=0;i<state.getNumTanks();++i)
	{
		if(!state.getTank(i)->getDead())
		{
			shared_ptr<PrimaryDispenser> disp(new ThreeWayDispenser());

			state.getTank(i)->addPrimaryDispenser(disp);
		}
	}
}
